#include "simple_synth.h"
/* If the needed signal is already cached (memoized), answer from memory.  
If not, do calculations, insert into memory, then answer. */

float * getwave(mitem *memohead,float *sin_table, note n){
	int i;
	unsigned int milliradians;
	float *env, mrad_per_samp;
	mitem *memo;
	if ((memo = find_memo(memohead, n))) return(memo->wave);
	memo = add_memo_to_tail(memohead, n);
	env = make_env(n);
	mrad_per_samp = n.F * 1000;
	for(i=0; i < n.A + n.D + n.S + n.R; i++) {
		milliradians = (unsigned int)(mrad_per_samp * i) % 6283;
		memo->wave[i] = env[i] * n.L * sin_table[milliradians];
	}
	return(memo->wave);
	free(env);
}
