#include "simple_synth.h"

#define BUFELEMS 1024
#define DELTA 0.001
/* argv[1] is the peak level in the input */

void usage(char *progname) {
	fprintf(stderr, "usage: %s <peak_amplitude>\n", progname);
	exit(1);
}

int main(int argc, char **argv) {
	int ret, i;
	float x[BUFELEMS], factor, max, poslimit, neglimit;
	SNDFILE *outfile = NULL;
	SF_INFO sfinfo;
	if (2 != argc) usage(argv[0]);
	assert(0 == setup_wav_output(&outfile, &sfinfo)); 
	max = atof(argv[1]);
	assert(max != 0);

	factor = 1 / max;	
	poslimit = +1 * max + DELTA;
	neglimit = -1 * max - DELTA;
	
	while((ret = fread(x, sizeof(float), BUFELEMS, stdin))) {
		for(i=0; i<ret; i++) {
			assert(x[i] <= poslimit);
			assert(x[i] >= neglimit);
			x[i] *= factor;
		}
		assert(ret == sf_write_float(outfile, x, (sf_count_t)ret));
	}
	sf_close(outfile);
	return(0);
}
		
	
	
