#include "simple_synth.h"

int setup_mmap_buf(int num_samples, float **x) {
	char tempfile[] = "/big/tmp/synthtmp.XXXXXX";
	int fd, pagesize, filesize, ret, i;
	void *map;
	unsigned char zero = 0;
	fd = mkstemp(tempfile);	assert (-1 != fd);
	pagesize = getpagesize();
	filesize = num_samples * sizeof(float);
	if (0 != filesize % pagesize) { /* mmap() works on whole pages */
		filesize = pagesize * (filesize / pagesize + 1);
	}
	num_samples = filesize / sizeof(float);
	ret = lseek(fd, filesize - 1, SEEK_SET); assert(ret == filesize - 1);
	ret = write(fd, &zero, 1); assert(1 == ret);	
	map = mmap(0, filesize, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);	
	assert(MAP_FAILED != map);
	*x = (float *) map;
	for(i=0; i<num_samples; i++) (*x)[i] = 0;
	printf("%s ", tempfile);
	return(fd);
}
