#include "simple_synth.h"

/* argv[1] = number of samples */

int main(int argc, char **argv) {
	mitem *memohead;
	float sin_table[6283], F, L, *x, max = -1;
	int i, num_samples, N, fd, A, D, S, R;
	if (2 != argc) usage(argv[0]);
	num_samples = atoi(argv[1]);
	for(i=0; i<6283; i++) sin_table[i] = sin((float)i/1000);
	fd = setup_mmap_buf(num_samples, &x);
	memohead = malloc(sizeof(mitem)); assert(NULL != memohead);
	memohead->n.F = -1;
	memohead->next = NULL;
	
	/* These parameters are documented in README. */
	while(7 == scanf("%f%d%f%d%d%d%d", &F, &N, &L, &A, &D, &S, &R)) {
		note nt = {F, L, A, D, S, R};
		float *wave;
		sanity(nt, N, num_samples);
		wave = getwave(memohead, sin_table, nt);
		for(i=N; i < N+A+D+S+R; i++) x[i] += wave[i - N];
	}
	for(i=0; i<num_samples; i++) max = fabsf(x[i]) > max ? fabsf(x[i]) : max;
	close(fd);
	printf("%f\n", max);
	return(0);
}

